// Code generated by protoc-gen-validate. DO NOT EDIT.
// source: envoy/extensions/filters/network/connection_limit/v3/connection_limit.proto

package envoy_extensions_filters_network_connection_limit_v3

import (
	"bytes"
	"errors"
	"fmt"
	"net"
	"net/mail"
	"net/url"
	"regexp"
	"strings"
	"time"
	"unicode/utf8"

	"google.golang.org/protobuf/types/known/anypb"
)

// ensure the imports are used
var (
	_ = bytes.MinRead
	_ = errors.New("")
	_ = fmt.Print
	_ = utf8.UTFMax
	_ = (*regexp.Regexp)(nil)
	_ = (*strings.Reader)(nil)
	_ = net.IPv4len
	_ = time.Duration(0)
	_ = (*url.URL)(nil)
	_ = (*mail.Address)(nil)
	_ = anypb.Any{}
)

// Validate checks the field values on ConnectionLimit with the rules defined
// in the proto definition for this message. If any rules are violated, an
// error is returned.
func (m *ConnectionLimit) Validate() error {
	if m == nil {
		return nil
	}

	if utf8.RuneCountInString(m.GetStatPrefix()) < 1 {
		return ConnectionLimitValidationError{
			field:  "StatPrefix",
			reason: "value length must be at least 1 runes",
		}
	}

	if wrapper := m.GetMaxConnections(); wrapper != nil {

		if wrapper.GetValue() < 1 {
			return ConnectionLimitValidationError{
				field:  "MaxConnections",
				reason: "value must be greater than or equal to 1",
			}
		}

	}

	if v, ok := interface{}(m.GetDelay()).(interface{ Validate() error }); ok {
		if err := v.Validate(); err != nil {
			return ConnectionLimitValidationError{
				field:  "Delay",
				reason: "embedded message failed validation",
				cause:  err,
			}
		}
	}

	if v, ok := interface{}(m.GetRuntimeEnabled()).(interface{ Validate() error }); ok {
		if err := v.Validate(); err != nil {
			return ConnectionLimitValidationError{
				field:  "RuntimeEnabled",
				reason: "embedded message failed validation",
				cause:  err,
			}
		}
	}

	return nil
}

// ConnectionLimitValidationError is the validation error returned by
// ConnectionLimit.Validate if the designated constraints aren't met.
type ConnectionLimitValidationError struct {
	field  string
	reason string
	cause  error
	key    bool
}

// Field function returns field value.
func (e ConnectionLimitValidationError) Field() string { return e.field }

// Reason function returns reason value.
func (e ConnectionLimitValidationError) Reason() string { return e.reason }

// Cause function returns cause value.
func (e ConnectionLimitValidationError) Cause() error { return e.cause }

// Key function returns key value.
func (e ConnectionLimitValidationError) Key() bool { return e.key }

// ErrorName returns error name.
func (e ConnectionLimitValidationError) ErrorName() string { return "ConnectionLimitValidationError" }

// Error satisfies the builtin error interface
func (e ConnectionLimitValidationError) Error() string {
	cause := ""
	if e.cause != nil {
		cause = fmt.Sprintf(" | caused by: %v", e.cause)
	}

	key := ""
	if e.key {
		key = "key for "
	}

	return fmt.Sprintf(
		"invalid %sConnectionLimit.%s: %s%s",
		key,
		e.field,
		e.reason,
		cause)
}

var _ error = ConnectionLimitValidationError{}

var _ interface {
	Field() string
	Reason() string
	Key() bool
	Cause() error
	ErrorName() string
} = ConnectionLimitValidationError{}
